config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  resources :scores

  resources :works

  resources :work_records

  root 'users#show'

end

app/models/work_record.rb
class WorkRecord < ActiveRecord::Base
  belongs_to :work

  scope :when, ->(date) { where('created_at >= ?', date.beginning_of_day).where('created_at <= ?', date.end_of_day)}
  scope :belongs_to_user, ->(user) { where(work_id: user.works.map {|w| w.id}) }
end

app/controllers/work_records_controller.rb
class WorkRecordsController < ApplicationController
  before_action :set_work_record, only: [:show, :edit, :update, :destroy]
  before_action :set_user, only: [:index]

  def index
    @user = current_user
    if @user
      @work_records = WorkRecord.belongs_to_user(@user).order(:created_at)
    else
      @work_records = WorkRecord.all
    end
  end

  def new
    @work_record = WorkRecord.new
  end

  def edit

  end

  def show
    #@work_record = WorkRecord.find(work_record_params[:id])
  end

  def create
    @work_record = WorkRecord.new(work_record_params)

    respond_to do |format|
      if @work_record.save
        format.html { redirect_to @work_record.work.user, notice: 'Work record was successfully created.' }
        format.json { render :show, status: :created, location: @work_record }
        format.js { @user = @work_record.work.user }
      else
        format.html { redirect_to @work_record.work.user, notice: 'Work record is not created.' }
        format.json { render json: @work_record.errors, status: :unprocessable_entity }
      end
    end
  end

  def update
    respond_to do |format|
      if @work_record.update(work_record_params)
        format.html { redirect_to @work_record, notice: 'Work record was successfully updated.' }
        format.json { render :show, status: :ok, location: @work_record }
      else
        format.html { render :edit }
        format.json { render json: @work_record.errors, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    @work_record.destroy
    respond_to do |format|
      format.html { redirect_to work_records_url, notice: 'Work record was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
  def set_work_record
    @work_record = WorkRecord.find(params[:id])
  end

  def set_user
    @user = User.find(params[:user_id]) if params[:user_id]

  end

  def work_record_params
    params.require(:work_record).permit(:work_id, :comment)
  end
end

app/helpers/work_records_helper.rb
module WorkRecordsHelper
end

app/views/work_records/_form.html.erb
<%= form_for(@work_record) do |f| %>
    <% if @work_record.errors.any? %>
        <div id="error_explanation">
          <h2><%= pluralize(@work_record.errors.count, "error") %> prohibited this work record from being saved:</h2>

          <ul>
            <% @work_record.errors.full_messages.each do |message| %>
                <li><%= message %></li>
            <% end %>
          </ul>
        </div>
    <% end %>

    <div class="field">
      <%= f.label :work_id %><br>
      <%= f.text_field :work_id %>
    </div>
    <div class="field">
      <%= f.label :comment %><br>
      <%= f.text_field :comment %>
    </div>
    <div class="actions">
      <%= f.submit %>
    </div>
<% end %>

app/views/work_records/create.js.erb
$('#check_form').html("<%= escape_javascript(render 'users/check_form') %>");
$('#checked_works').html("<%= escape_javascript(render 'users/checked_works') %>");
$('#notice').html("<%= escape_javascript(notice) %>");

app/views/work_records/edit.html.erb
<h1>Editing Work Record</h1>

<%= render 'form' %>

<%= link_to 'Show', @work_record %> |
<%= link_to 'Back', work_records_path %>

app/views/work_records/index.html.erb
<% if @user %>
  <h3>All Records of <%= @user.name %></h3>
<% end %>
<table>
  <thead>
  <tr>
    <th>Work</th>
    <th colspan="4">Record</th>
  </tr>
  </thead>
  <tbody>
  <% @work_records.each do |rec| %>
    <tr>
      <td><%= rec.work.name %></td>
      <td><%= rec.created_at%></td>
      <td><%= link_to 'Show', rec %></td>
      <td><%= link_to 'Edit', edit_work_record_path(rec) %></td>
      <td><%= link_to 'Destroy', rec, method: :delete, data: { confirm: 'Are you sure?' } %></td>
    </tr>
  <% end %>
  </tbody>
</table>
<%= link_to('Back', root_path) if @user %>

app/views/work_records/new.html.erb
<h1>New Work Record</h1>

<%= render 'form' %>

<%= link_to 'Back', work_records_path %>

app/views/work_records/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Work:</strong>
  <%= @work_record.work.name %>
</p>

<p>
  <strong>Comment:</strong>
  <%= @work_record.comment %>
</p>

<p>
  <strong>Time:</strong>
  <%= @work_record.created_at %>
</p>

<%= link_to 'Edit', edit_work_record_path(@work_record) %> |
<%= link_to 'Back', work_records_path %>